/*
 *  module.c
 *  
 *  Author  : Ahmed Obied (ahmed.obied@gmail.com)
 *  Version : 0.1
 * 
 *  Skeleton for a system call hooker
 *
 */
   
#define __KERNEL__
#define MODULE
#include <linux/module.h>
#include <sys/syscall.h>
#include <string.h>

unsigned long *sys_call_table;
int (*org_mkdir_call)(const char *pathname, mode_t mode);

int intercepted_mkdir_call(const char *pathname, mode_t mode)
{
	if (strcmp(pathname,"example") == 0) 
		return org_mkdir_call(pathname,mode);
	else
		return 0;
}

int init_module()
{
	sys_call_table = (unsigned long *)0xc03726f4; 
	org_mkdir_call = (void *)sys_call_table[SYS_mkdir];
	sys_call_table[SYS_mkdir] = (int)intercepted_mkdir_call;	
	return 0;
}

void cleanup_module()
{
	sys_call_table[SYS_mkdir] = (int)org_mkdir_call;
}

